/*
	File:		MoreDialogs.h

	Contains:	

	Written by:	Pete Gontier (PCG)

	Copyright:	Copyright (c) 1998 Apple Computer, Inc.

	Change History (most recent first):

         <6>      9/9/98    PCG     re-work import and export pragmas
         <5>      9/1/98    PCG     Universal Headers 3.2
         <4>     7/24/98    PCG	    coddle linker (C++, CFM-68K)
         <3>     7/24/98    PCG	    add MoveableModalDialog
         <2>     7/24/98    PCG	    eliminate dependency on 'qd'
         <1>     6/16/98    PCG     initial checkin
*/


#pragma once

#include "MorePrefix.h"

#include <Dialogs.h>

enum { kDialogItemIndexNone = -1 };

#ifdef __cplusplus
	extern "C" {
#endif

#pragma import on // for clients
#pragma export on // for building a library

#if UNIVERSAL_INTERFACES_VERSION < 0x0320

	extern pascal OSErr AppendDialogItemList (DialogPtr dialog, SInt16 ditlID, DITLMethod method)
		THREEWORDINLINE (0x303C, 0x0412, 0xAA68);

#endif // UNIVERSAL_INTERFACES_VERSION < 0x0320

pascal void			SaferShortenDITL			(DialogPtr, DialogItemIndex);
pascal DialogPtr	MoreGetNewDialog			(short dlogResID);
pascal void			SetDialogItemString			(DialogPtr, DialogItemIndex, ConstStr255Param);
pascal void			GetDialogItemString			(DialogPtr, DialogItemIndex, StringPtr);
pascal void			SelectAllDialogItemText		(DialogPtr, DialogItemIndex);
pascal void			MoveableModalDialog			(ModalFilterUPP, short *itemHit);

#pragma import reset // for clients
#pragma export reset // for building a library

#ifdef __cplusplus
	}
#endif
