/*
	File:		MorePreferences.h

	Contains:	

	Written by:	Pete Gontier (PCG)

	Copyright:	Copyright (c) 1998 Apple Computer, Inc.

	Change History (most recent first):

         <3>      9/9/98    PCG     re-work import and export pragmas
         <2>     7/24/98    PCG	    coddle linker (C++, CFM-68K)
         <1>     6/16/98    PCG     initial checkin
*/


#pragma once

#include <Files.h>

enum
{
	kPrefsReservedType		= 'prrt',
	kPrefsFileType			= 'pref'
};

typedef FourCharCode	PrefsType;
typedef UInt32			PrefsID;

typedef struct OpaquePrefsCollection *PrefsCollection;

#ifdef __cplusplus
	extern "C" {
#endif

#pragma import on // for clients
#pragma export on // for building a library

pascal OSErr GetPreferenceSize				(PrefsCollection, PrefsType, PrefsID, Size *);
pascal OSErr GetPreference					(PrefsCollection, PrefsType, PrefsID, Size, Size *actualSize, void *);
pascal OSErr SetPreference					(PrefsCollection, PrefsType, PrefsID, Size, void *);
pascal OSErr NewPrefsCollection				(PrefsCollection *);
pascal OSErr DisposePrefsCollection			(PrefsCollection);
pascal OSErr GetNewPrefsCollection			(PrefsCollection *, ConstStr255Param fileName);
pascal OSErr WritePrefsCollection			(PrefsCollection, ConstStr255Param fileName);
pascal OSErr GetNewPrefsCollectionFromFile	(PrefsCollection *, const FSSpec *);
pascal OSErr WritePrefsCollectionToFile		(PrefsCollection, const FSSpec *);
pascal OSErr PrefsAreSame					(PrefsCollection, PrefsCollection, Boolean *);
pascal OSErr CreatePrefsFolder				(ConstStr255Param, long *dirID);

#pragma import reset // for clients
#pragma export reset // for building a library

#ifdef __cplusplus
	}
#endif
