/*
	File:		MoreProcesses.cp

	Contains:	

	Written by:	Pete Gontier (PCG)

	Copyright:	Copyright (c) 1998 Apple Computer, Inc.

	Change History (most recent first):

         <1>     6/16/98    PCG     initial checkin
*/


#include "MoreProcesses.h"

pascal OSErr GetSomeProcessInfo (const ProcessSerialNumber *psn, ProcessInfoRec *pir)
{
	if (!MoreAssert (pir))
		return paramErr;

	pir->processInfoLength	= sizeof (*pir);
	pir->processName		= nil;
	pir->processAppSpec		= nil;

	if (psn)
		return GetProcessInformation (psn,pir);
	else
	{
		ProcessSerialNumber psn = { kNoProcess, kCurrentProcess };
		return GetProcessInformation (&psn,pir);
	}
}

pascal OSErr FindProcessBySignature (OSType processSignature, ProcessSerialNumber *psn)
{
	OSErr err = noErr;

	psn->lowLongOfPSN	= kNoProcess;
	psn->highLongOfPSN	= kNoProcess;

	while (!(err = GetNextProcess (psn)))
	{
		ProcessInfoRec pir;

		if (!(err = GetSomeProcessInfo (psn,&pir)))
			if (processSignature == pir.processSignature)
				break;
	}

	return err;
}
