/*
	File:		MoreToolbox.cp

	Contains:	

	Written by:	Pete Gontier (PCG)

	Copyright:	Copyright (c) 1998 Apple Computer, Inc.

	Change History (most recent first):

         <2>     7/24/98    PCG	    eliminate dependency on 'qd'
         <1>     6/16/98    PCG     initial checkin
*/


#include "MoreToolbox.h"
#include "MoreQuickDraw.h"
#include "MoreAppearance.h"

#include <MacMemory.h>
#include <Fonts.h>
#include <Dialogs.h>
#include <Sound.h>
#include <Gestalt.h>

static long gSystemVersion;

pascal long GetSystemVersion (void)
{
	//
	//	Simply returns our cached variable. See InitMac
	//	for how this variable is initialized.
	//

	return gSystemVersion;
}

pascal Boolean HaveAppleEvents (void)
{
	return 0x0700 <= GetSystemVersion ( ); // cheating
}

pascal OSStatus InitMac (QDGlobalsPtr qd)
{
	OSStatus err = noErr;

	if (!(err = Gestalt (gestaltSystemVersion, &gSystemVersion)))
	{
		MaxApplZone ( );
		(void) MoreAssert (MemError ( ) == noErr);

		InitGraf (&(qd->thePort));
		InitFonts ( );
		InitWindows ( );
		InitMenus ( );
		TEInit ( );
		InitDialogs (nil);

		if (!(err = InitMoreQuickDraw ( )))
		{
			if (!(err = InitMoreAppearance ( )))
			{
				err = ShowWatchCursor (qd);
			}
		}
	}

	return err;
}

pascal void Beep (void)
{
	SysBeep (10);
}

pascal OSErr ShowWatchCursor (QDGlobalsPtr qd)
{
	OSErr err = noErr;

	CursHandle watchFob = GetCursor (watchCursor);

	if (!watchFob)
		err = nilHandleErr;
	else
	{
		Cursor preservedArrow = qd->arrow;
		qd->arrow = **watchFob;
		InitCursor ( );
		qd->arrow = preservedArrow;
	}

	return err;
}
