/*************************************************************************************
#
#	GridTilesFormat.h
#	
#	This file describes the formats of a TileCollection and a TileGrid.  We provide them both here so
#   that our applications that build compiled files can also access the resource format.
#
#	Author: Timothy Carroll
#	Apple Developer Technical Support
#	timc@apple.com
#
#	Modification History: 
#
#	8/15/96		TMC 	Initial Release
#
#	Copyright  1996 Apple Computer, Inc., All Rights Reserved
#
#
#	You may incorporate this sample code into your applications without
#	restriction, though the sample code has been provided "AS IS" and the
#	responsibility for its operation is 100% yours.  However, what you are
#	not permitted to do is to redistribute the source as "DSC Sample Code"
#	after having made changes. If you're going to re-distribute the source,
#	we require that you make it clear in the source that the code was
#	descended from Apple Sample Code, but that you've made changes.
#
*************************************************************************************/


/****************************************************************************************************
Resource Data Structures
****************************************************************************************************/

typedef struct TileCollectionResHeader TileCollectionResHeader;
const UInt32 TileCollectionResType = 'TILE';

struct TileCollectionResHeader
{
	UInt32 version;
	SInt16 depth;
	UInt16 flags;
	UInt32 numTiles;
	
	// Followed by 1k per tile in 32x32x8 bit format.
};


typedef UInt16 CellGridType;

typedef struct TileGridResHeader TileGridResHeader;
const UInt32 TileGridResType = 'GRID';

struct TileGridResHeader
{
	UInt32 version;
	UInt16 flags;
	SInt16 tileResID;
	UInt32 width;
	UInt32 height;
	UInt32 defaultTile;

	// followed by width x height x CellGridType for tile information in row x column format.
};
