/*
	File:		OTSimpleDownloadHTTP.h

	Contains:	Interface to the simple HTTP download sample.

	Written by:	Quinn "The Eskimo!"

	Copyright:	 1997 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

	You may incorporate this sample code into your applications without
	restriction, though the sample code has been provided "AS IS" and the
	responsibility for its operation is 100% yours.  However, what you are
	not permitted to do is to redistribute the source as "DSC Sample Code"
	after having made changes. If you're going to re-distribute the source,
	we require that you make it clear in the source that the code was
	descended from Apple Sample Code, but that you've made changes.
*/

#include <Types.h>

OSStatus DownloadHTTPSimple(const char *hostName,
							const char *httpCommand,
							const short destFileRefNum);

// Download a URL from the a web server.  hostName is a pointer
// to a string that contains the DNS address of the web server.
// The DNS address must be suffixed by ":<port>", where <port>
// is the port number the web server is operating on.
// httpCommand contains the HTTP command to send.  Typically this
// is of the form:
//
//		GET <x> HTTP/1.0\0x13\0x10\0x13\0x10
//
// where <x> is the URL path.  destFileRefNum is the file
// reference number to which the results of the HTTP command
// are written.  This routine does not parse the returned HTTP
// header in any way.  The entire incoming stream goes into
// the file verbatim.
//
// For example, if you were asked to download a URL like:
//
//		http://devworld.apple.com/dev/technotes.shtml
//
// you would set:
//
// 		o hostName to "devworld.apple.com:80" (80 is the
//		  default port for HTTP.
//		o httpCommand to "GET /dev/technotes.shtml HTTP/1.0\0x13\0x10\0x13\0x10"
