/*
	File:		ProviderFactory.h

	Contains:	Interface to our provider factory library.

	Written by:	Quinn "The Eskimo!"

	Copyright:	 1997 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

	You may incorporate this sample code into your applications without
	restriction, though the sample code has been provided "AS IS" and the
	responsibility for its operation is 100% yours.  However, what you are
	not permitted to do is to redistribute the source as "DSC Sample Code"
	after having made changes. If you're going to re-distribute the source,
	we require that you make it clear in the source that the code was
	descended from Apple Sample Code, but that you've made changes.
*/

////////////////////////////////////////////////////////////
// Pick up general Open Transport stuff.

#include <OpenTransport.h>

////////////////////////////////////////////////////////////
// Provider factory definitions.

extern OSStatus FactoryCreateEndpoint(EndpointRef *ref, OTClient *currentOwner);
	// This routine creates an endpoint for you, passing back
	// the EndpointRef and the current owner.  You can then
	// call OTTransferProviderOwnership to 
	
////////////////////////////////////////////////////////////
// Initialisation and termination routines.

extern OSStatus InitProviderFactory(void);
	// Call this before calling FactoryCreateEndpoint.
	
extern void CloseProviderFactory(void);
	// Call this after you've created all the endpoints you
	// need from the factory.  Make sure you have transferred
	// the ownership of all these endpoints before calling this,
	// otherwise OT will assume that the factory still owns the
	// endpoints, and clean them up for you!
