#-----------------------------------------------------------------------#
#																		#
#	Program:	ImageerPPC												#
#	File:		ImageerPPC.make	-	Make Source							#
#																		#
#	By:			Jason Hodges-Harris										#
#																		#
#	Version:	1.0d2													#
#																		#
#	Copyright:	 1995-96 Apple Computer, Inc.,							#
#					all rights reserved.								#	
#																		#
#-----------------------------------------------------------------------#

AppName			=	'ImageerPPC'
Signature		=	'Im#'
projsrc			=	:source:
PPCC			=	MrC
obj				= 	:object:
SymPPC     	=	-sym on
OptsPPC		=	-proto strict
ObjDirPPC		=	:object:

PPCCOptions		=	{Includes} {SymPPC} {OptsPPC}

{obj}				{projsrc}

{obj}.c.o			{projsrc}.c
	{MrC} {PPCCOptions} {DepDir}{Default}.c -o {TargDir}{Default}.c.x

#------------------------------------------------------------------------------
# These are the objects that we want to link with. If any one of these
# changes, then we invoke the Link command.
#------------------------------------------------------------------------------
AppObjects		=	
					{obj}doevent.c.x 
					{obj}eventloop.c.x 
					{obj}fileCache.c.x 
					{obj}fileIO.c.x 
					{obj}gxGraphics.c.x 
					{obj}imageFilter.c.x 
					{obj}menu.c.x 
					{obj}offscrnGraphics.c.x 
					{obj}start.c.x 
					{obj}windows.c.x

PPCSysObjects = 
		"{SharedLibraries}"InterfaceLib 
		"{SharedLibraries}"StdCLib 
		"{SharedLibraries}MathLib" 
		"{SharedLibraries}"QuickTimeLib 
		"{PPCLibraries}"StdCRuntime.o 
		"{PPCLibraries}"PPCCRuntime.o 
		"{PPCLibraries}"PPCToolLibs.o 
		"{PPCLibraries}"QuickDrawGXLib.xcoff 
		-librename QuickDrawGXLib.xcoff=QuickDrawGXLib 
		-weakLib QuickTimeLib 
		-weakLib QuickDrawGXLib
		

{AppObjects}			ImageerPPC.make 
					{projsrc}Imageer.app.h 
					{projsrc}Imageer.protos.h 


{AppName}			 ShellForce


ShellForce			
	BEGIN
		IF "{ShellVersion}" == ""
			( EVALUATE "`Version`" =~ /MPW Shell ([0-9]+(.[ab0-9]+)+)1/ )  Dev:Null
			SET ShellVersion "{1}"
		END
	END  Dev:Null # Output to bit bucket so we dont see above calculations


{AppName}			 {AppObjects}
	Rez -append {projsrc}Imageer.r -o {AppName}
	PPCLink {SymPPC} -w 
	-o {Targ} {AppObjects} 
	-t APPL 
	-c {Signature} 
	{PPCSysObjects}

#------------------------------------------------------------------------------
# Build rule that creates our resources and adds them to the application
#------------------------------------------------------------------------------

{AppName}			ImageerPPC.make 
					{projsrc}Imageer.app.h 
					{projsrc}Imageer.protos.h
