/*
**	Apple Macintosh Developer Technical Support
**
**	Headers for routines demonstrating how to manipulate buffers containing WAVE sounds.
**
**	by Mark Cookson, Apple Developer Technical Support
**
**	File:	MungeBuffer.h
**
**	Copyright 1996 Apple Computer, Inc.
**	All rights reserved.
**
**	You may incorporate this sample code into your applications without
**	restriction, though the sample code has been provided "AS IS" and the
**	responsibility for its operation is 100% yours.  However, what you are
**	not permitted to do is to redistribute the source as "Apple Sample
**	Code" after having made changes. If you're going to re-distribute the
**	source, we require that you make it clear in the source that the code
**	was descended from Apple Sample Code, but that you've made changes.
*/

#ifndef __MUNGEBUFFER__
#define __MUNGEBUFFER__

#include <Types.h>

#ifndef __DEFINES__
#include "Defines.h"
#endif

/* Comment out the next line to use C functions instead of assembly functions. */
#define ASM

#ifdef ASM

asm	void	Endian16BitBuffer			(Ptr buf,
										unsigned long count);
#else

	void	Endian16BitBuffer			(Ptr buf,
										unsigned long count);

#endif

void ReverseMono8BitBuffer (const Ptr buf, unsigned long count);
void ReverseStereo8BitBuffer (const Ptr buf, unsigned long count);
void ReverseMono16BitBuffer (const Ptr buf, unsigned long count);
void ReverseStereo16BitBuffer (const Ptr buf, unsigned long count);

#endif