/*
	SquareWaveSynthPlay 12:29:17 PM  10/13/92   Brigham Stevens
	
	Plays a sound using the squareWaveSynth.

	Sets the timbre with timbreCmd
	Starts playing witht the freqCmd
	
##
##	copy to worksheet, select, press enter
###	
##	BuildCommands:
##
	C -r  SquareWaveSynthPlay.c
	Link -t APPL -c '????' SquareWaveSynthPlay.c.o 
		"{Libraries}"Runtime.o 
		"{Libraries}"Interface.o 
		-o SquareWaveSynthPlay
	SquareWaveSynthPlay
*/

#include <Dialogs.h>
#include <Sound.h>

void SquareWaveSynthPlay();

void SquareWaveSynthPlay()
{
	SndChannelPtr	chan;
	SndCommand		mycmd;
	long			count;
	short			change = 0;
	short			err;
	
	
	/* Allocate a channel tied to the squareWaveSynth */
	chan = nil;
	err = SndNewChannel (&chan, squareWaveSynth, 0, nil);
	if (err) {
		DebugStr("\p error SndNewChannel [2]");
		goto bail;
	}
	
	mycmd.cmd = freqCmd;
	mycmd.param1 = 0;
	mycmd.param2 = 50;
	
	err = SndDoImmediate (chan, &mycmd);
	if (err) {
		DebugStr("\p error SndDoImmediate [3]");
		goto bail;
	}
		
	mycmd.cmd = timbreCmd;
	mycmd.param1 = 0;
	mycmd.param2 = 86;
	
	err = SndDoImmediate (chan, &mycmd);
	if (err) {
		DebugStr("\p error SndDoImmediate [3]");
		goto bail;
	}
	
	Delay (180, &count);
		
	err = SndDisposeChannel (chan,false);
	if (err) {
		DebugStr("\p error SndDisposeChannel [2]");
		goto bail;
	}
bail:
	return;
}


void main()
{
	SquareWaveSynthPlay();
}